// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSFuselageStringerFramePosition.h"
#include "CPACSAlignmentStringFrame.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSAlignmentStringFrame::CPACSAlignmentStringFrame(CCPACSFuselageStringerFramePosition* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSAlignmentStringFrame::~CPACSAlignmentStringFrame()
    {
        if (m_uidMgr) m_uidMgr->TryUnregisterObject(m_uID);
    }

    const CCPACSFuselageStringerFramePosition* CPACSAlignmentStringFrame::GetParent() const
    {
        return m_parent;
    }

    CCPACSFuselageStringerFramePosition* CPACSAlignmentStringFrame::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSAlignmentStringFrame::GetNextUIDParent() const
    {
        return m_parent;
    }

    CTiglUIDObject* CPACSAlignmentStringFrame::GetNextUIDParent()
    {
        return m_parent;
    }

    CTiglUIDManager& CPACSAlignmentStringFrame::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSAlignmentStringFrame::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSAlignmentStringFrame::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read attribute uID
        if (tixi::TixiCheckAttribute(tixiHandle, xpath, "uID")) {
            m_uID = tixi::TixiGetAttribute<std::string>(tixiHandle, xpath, "uID");
            if (m_uID.empty()) {
                LOG(WARNING) << "Required attribute uID is empty at xpath " << xpath;
            }
        }
        else {
            LOG(ERROR) << "Required attribute uID is missing at xpath " << xpath;
        }

        // read element rotationLocX
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/rotationLocX")) {
            m_rotationLocX = tixi::TixiGetElement<double>(tixiHandle, xpath + "/rotationLocX");
        }

        // read element translationLocY
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/translationLocY")) {
            m_translationLocY = tixi::TixiGetElement<double>(tixiHandle, xpath + "/translationLocY");
        }

        // read element translationLocZ
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/translationLocZ")) {
            m_translationLocZ = tixi::TixiGetElement<double>(tixiHandle, xpath + "/translationLocZ");
        }

        if (m_uidMgr && !m_uID.empty()) m_uidMgr->RegisterObject(m_uID, *this);
    }

    void CPACSAlignmentStringFrame::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write attribute uID
        tixi::TixiSaveAttribute(tixiHandle, xpath, "uID", m_uID);

        // write element rotationLocX
        if (m_rotationLocX) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/rotationLocX");
            tixi::TixiSaveElement(tixiHandle, xpath + "/rotationLocX", *m_rotationLocX);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/rotationLocX")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/rotationLocX");
            }
        }

        // write element translationLocY
        if (m_translationLocY) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/translationLocY");
            tixi::TixiSaveElement(tixiHandle, xpath + "/translationLocY", *m_translationLocY);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/translationLocY")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/translationLocY");
            }
        }

        // write element translationLocZ
        if (m_translationLocZ) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/translationLocZ");
            tixi::TixiSaveElement(tixiHandle, xpath + "/translationLocZ", *m_translationLocZ);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/translationLocZ")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/translationLocZ");
            }
        }

    }

    const std::string& CPACSAlignmentStringFrame::GetUID() const
    {
        return m_uID;
    }

    void CPACSAlignmentStringFrame::SetUID(const std::string& value)
    {
        if (m_uidMgr && value != m_uID) {
            if (m_uID.empty()) {
                m_uidMgr->RegisterObject(value, *this);
            }
            else {
                m_uidMgr->UpdateObjectUID(m_uID, value);
            }
        }
        m_uID = value;
    }

    const boost::optional<double>& CPACSAlignmentStringFrame::GetRotationLocX() const
    {
        return m_rotationLocX;
    }

    void CPACSAlignmentStringFrame::SetRotationLocX(const boost::optional<double>& value)
    {
        m_rotationLocX = value;
    }

    const boost::optional<double>& CPACSAlignmentStringFrame::GetTranslationLocY() const
    {
        return m_translationLocY;
    }

    void CPACSAlignmentStringFrame::SetTranslationLocY(const boost::optional<double>& value)
    {
        m_translationLocY = value;
    }

    const boost::optional<double>& CPACSAlignmentStringFrame::GetTranslationLocZ() const
    {
        return m_translationLocZ;
    }

    void CPACSAlignmentStringFrame::SetTranslationLocZ(const boost::optional<double>& value)
    {
        m_translationLocZ = value;
    }

} // namespace generated
} // namespace tigl
