// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSFuselageWallSegment.h"
#include "CPACSBoundingElementUIDs.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSBoundingElementUIDs::CPACSBoundingElementUIDs(CCPACSFuselageWallSegment* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSBoundingElementUIDs::~CPACSBoundingElementUIDs()
    {
        if (m_uidMgr) {
            for (std::vector<std::string>::iterator it = m_boundingElementUIDs.begin(); it != m_boundingElementUIDs.end(); ++it) {
                if (!it->empty()) m_uidMgr->TryUnregisterReference(*it, *this);
            }
        }
    }

    const CCPACSFuselageWallSegment* CPACSBoundingElementUIDs::GetParent() const
    {
        return m_parent;
    }

    CCPACSFuselageWallSegment* CPACSBoundingElementUIDs::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSBoundingElementUIDs::GetNextUIDParent() const
    {
        if (m_parent) {
            if (m_parent->GetUID())
                return m_parent;
            else
                return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSBoundingElementUIDs::GetNextUIDParent()
    {
        if (m_parent) {
            if (m_parent->GetUID())
                return m_parent;
            else
                return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSBoundingElementUIDs::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSBoundingElementUIDs::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSBoundingElementUIDs::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element boundingElementUID
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/boundingElementUID")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/boundingElementUID", m_boundingElementUIDs, 1, tixi::xsdUnbounded);
            if (m_uidMgr) {
                for (std::vector<std::string>::iterator it = m_boundingElementUIDs.begin(); it != m_boundingElementUIDs.end(); ++it) {
                    if (!it->empty()) m_uidMgr->RegisterReference(*it, *this);
                }
            }
        }

    }

    void CPACSBoundingElementUIDs::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element boundingElementUID
        tixi::TixiSaveElements(tixiHandle, xpath + "/boundingElementUID", m_boundingElementUIDs);

    }

    const std::vector<std::string>& CPACSBoundingElementUIDs::GetBoundingElementUIDs() const
    {
        return m_boundingElementUIDs;
    }

    std::vector<std::string>& CPACSBoundingElementUIDs::GetBoundingElementUIDs()
    {
        return m_boundingElementUIDs;
    }

    const CTiglUIDObject* CPACSBoundingElementUIDs::GetNextUIDObject() const
    {
        return GetNextUIDParent();
    }

    void CPACSBoundingElementUIDs::NotifyUIDChange(const std::string& oldUid, const std::string& newUid)
    {
        for (auto& entry : m_boundingElementUIDs) {
            if (entry == oldUid) {
                entry = newUid;
            }
        }
    }

} // namespace generated
} // namespace tigl
