// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include <CCPACSCrossBeamStrutAssemblyPosition.h>
#include "CCPACSFuselageStructure.h"
#include "CPACSCargoCrossBeamStrutsAssembly.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSCargoCrossBeamStrutsAssembly::CPACSCargoCrossBeamStrutsAssembly(CCPACSFuselageStructure* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSCargoCrossBeamStrutsAssembly::~CPACSCargoCrossBeamStrutsAssembly()
    {
    }

    const CCPACSFuselageStructure* CPACSCargoCrossBeamStrutsAssembly::GetParent() const
    {
        return m_parent;
    }

    CCPACSFuselageStructure* CPACSCargoCrossBeamStrutsAssembly::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSCargoCrossBeamStrutsAssembly::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSCargoCrossBeamStrutsAssembly::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSCargoCrossBeamStrutsAssembly::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSCargoCrossBeamStrutsAssembly::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSCargoCrossBeamStrutsAssembly::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element cargoCrossBeamStrut
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/cargoCrossBeamStrut")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/cargoCrossBeamStrut", m_cargoCrossBeamStruts, 1, tixi::xsdUnbounded, reinterpret_cast<CCPACSCargoCrossBeamStrutsAssembly*>(this), m_uidMgr);
        }

    }

    void CPACSCargoCrossBeamStrutsAssembly::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element cargoCrossBeamStrut
        tixi::TixiSaveElements(tixiHandle, xpath + "/cargoCrossBeamStrut", m_cargoCrossBeamStruts);

    }

    const std::vector<std::unique_ptr<CCPACSCrossBeamStrutAssemblyPosition>>& CPACSCargoCrossBeamStrutsAssembly::GetCargoCrossBeamStruts() const
    {
        return m_cargoCrossBeamStruts;
    }

    std::vector<std::unique_ptr<CCPACSCrossBeamStrutAssemblyPosition>>& CPACSCargoCrossBeamStrutsAssembly::GetCargoCrossBeamStruts()
    {
        return m_cargoCrossBeamStruts;
    }

    CCPACSCrossBeamStrutAssemblyPosition& CPACSCargoCrossBeamStrutsAssembly::AddCargoCrossBeamStrut()
    {
        m_cargoCrossBeamStruts.push_back(make_unique<CCPACSCrossBeamStrutAssemblyPosition>(reinterpret_cast<CCPACSCargoCrossBeamStrutsAssembly*>(this), m_uidMgr));
        return *m_cargoCrossBeamStruts.back();
    }

    void CPACSCargoCrossBeamStrutsAssembly::RemoveCargoCrossBeamStrut(CCPACSCrossBeamStrutAssemblyPosition& ref)
    {
        for (std::size_t i = 0; i < m_cargoCrossBeamStruts.size(); i++) {
            if (m_cargoCrossBeamStruts[i].get() == &ref) {
                m_cargoCrossBeamStruts.erase(m_cargoCrossBeamStruts.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
