// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include <CCPACSDoorAssemblyPosition.h>
#include "CCPACSFuselageStructure.h"
#include "CPACSCargoDoorsAssembly.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSCargoDoorsAssembly::CPACSCargoDoorsAssembly(CCPACSFuselageStructure* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSCargoDoorsAssembly::~CPACSCargoDoorsAssembly()
    {
    }

    const CCPACSFuselageStructure* CPACSCargoDoorsAssembly::GetParent() const
    {
        return m_parent;
    }

    CCPACSFuselageStructure* CPACSCargoDoorsAssembly::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSCargoDoorsAssembly::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSCargoDoorsAssembly::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSCargoDoorsAssembly::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSCargoDoorsAssembly::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSCargoDoorsAssembly::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element cargoDoor
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/cargoDoor")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/cargoDoor", m_cargoDoors, 1, tixi::xsdUnbounded, this, m_uidMgr);
        }

    }

    void CPACSCargoDoorsAssembly::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element cargoDoor
        tixi::TixiSaveElements(tixiHandle, xpath + "/cargoDoor", m_cargoDoors);

    }

    const std::vector<std::unique_ptr<CCPACSDoorAssemblyPosition>>& CPACSCargoDoorsAssembly::GetCargoDoors() const
    {
        return m_cargoDoors;
    }

    std::vector<std::unique_ptr<CCPACSDoorAssemblyPosition>>& CPACSCargoDoorsAssembly::GetCargoDoors()
    {
        return m_cargoDoors;
    }

    CCPACSDoorAssemblyPosition& CPACSCargoDoorsAssembly::AddCargoDoor()
    {
        m_cargoDoors.push_back(make_unique<CCPACSDoorAssemblyPosition>(this, m_uidMgr));
        return *m_cargoDoors.back();
    }

    void CPACSCargoDoorsAssembly::RemoveCargoDoor(CCPACSDoorAssemblyPosition& ref)
    {
        for (std::size_t i = 0; i < m_cargoDoors.size(); i++) {
            if (m_cargoDoors[i].get() == &ref) {
                m_cargoDoors.erase(m_cargoDoors.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
