// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSWingCell.h"
#include "CPACSCellPositioningChordwise.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSCellPositioningChordwise::CPACSCellPositioningChordwise(CCPACSWingCell* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSCellPositioningChordwise::~CPACSCellPositioningChordwise()
    {
        if (m_uidMgr) {
            if (m_sparUID_choice1 && !m_sparUID_choice1->empty()) m_uidMgr->TryUnregisterReference(*m_sparUID_choice1, *this);
        }
    }

    const CCPACSWingCell* CPACSCellPositioningChordwise::GetParent() const
    {
        return m_parent;
    }

    CCPACSWingCell* CPACSCellPositioningChordwise::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSCellPositioningChordwise::GetNextUIDParent() const
    {
        return m_parent;
    }

    CTiglUIDObject* CPACSCellPositioningChordwise::GetNextUIDParent()
    {
        return m_parent;
    }

    CTiglUIDManager& CPACSCellPositioningChordwise::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSCellPositioningChordwise::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSCellPositioningChordwise::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element sparUID
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/sparUID")) {
            m_sparUID_choice1 = tixi::TixiGetElement<std::string>(tixiHandle, xpath + "/sparUID");
            if (m_sparUID_choice1->empty()) {
                LOG(WARNING) << "Optional element sparUID is present but empty at xpath " << xpath;
            }
            if (m_uidMgr && !m_sparUID_choice1->empty()) m_uidMgr->RegisterReference(*m_sparUID_choice1, *this);
        }

        // read element contourCoordinate
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/contourCoordinate")) {
            m_contourCoordinate_choice2 = tixi::TixiGetElement<double>(tixiHandle, xpath + "/contourCoordinate");
        }

        // read element xsi1
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/xsi1")) {
            m_xsi1_choice3 = tixi::TixiGetElement<double>(tixiHandle, xpath + "/xsi1");
        }

        // read element xsi2
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/xsi2")) {
            m_xsi2_choice3 = tixi::TixiGetElement<double>(tixiHandle, xpath + "/xsi2");
        }

        if (!ValidateChoices()) {
            LOG(ERROR) << "Invalid choice configuration at xpath " << xpath;
        }
    }

    void CPACSCellPositioningChordwise::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element sparUID
        if (m_sparUID_choice1) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/sparUID");
            tixi::TixiSaveElement(tixiHandle, xpath + "/sparUID", *m_sparUID_choice1);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/sparUID")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/sparUID");
            }
        }

        // write element contourCoordinate
        if (m_contourCoordinate_choice2) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/contourCoordinate");
            tixi::TixiSaveElement(tixiHandle, xpath + "/contourCoordinate", *m_contourCoordinate_choice2);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/contourCoordinate")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/contourCoordinate");
            }
        }

        // write element xsi1
        if (m_xsi1_choice3) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/xsi1");
            tixi::TixiSaveElement(tixiHandle, xpath + "/xsi1", *m_xsi1_choice3);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/xsi1")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/xsi1");
            }
        }

        // write element xsi2
        if (m_xsi2_choice3) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/xsi2");
            tixi::TixiSaveElement(tixiHandle, xpath + "/xsi2", *m_xsi2_choice3);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/xsi2")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/xsi2");
            }
        }

    }

    bool CPACSCellPositioningChordwise::ValidateChoices() const
    {
        return
        (
            (
                (
                    // mandatory elements of this choice must be there
                    m_sparUID_choice1.is_initialized()
                    &&
                    // elements of other choices must not be there
                    !(
                        m_contourCoordinate_choice2.is_initialized()
                        ||
                        m_xsi1_choice3.is_initialized()
                        ||
                        m_xsi2_choice3.is_initialized()
                    )
                )
                +
                (
                    // mandatory elements of this choice must be there
                    m_contourCoordinate_choice2.is_initialized()
                    &&
                    // elements of other choices must not be there
                    !(
                        m_sparUID_choice1.is_initialized()
                        ||
                        m_xsi1_choice3.is_initialized()
                        ||
                        m_xsi2_choice3.is_initialized()
                    )
                )
                +
                (
                    // mandatory elements of this choice must be there
                    m_xsi1_choice3.is_initialized()
                    &&
                    m_xsi2_choice3.is_initialized()
                    &&
                    // elements of other choices must not be there
                    !(
                        m_sparUID_choice1.is_initialized()
                        ||
                        m_contourCoordinate_choice2.is_initialized()
                    )
                )
                == 1
            )
        )
        ;
    }

    const boost::optional<std::string>& CPACSCellPositioningChordwise::GetSparUID_choice1() const
    {
        return m_sparUID_choice1;
    }

    void CPACSCellPositioningChordwise::SetSparUID_choice1(const boost::optional<std::string>& value)
    {
        if (m_uidMgr) {
            if (m_sparUID_choice1 && !m_sparUID_choice1->empty()) m_uidMgr->TryUnregisterReference(*m_sparUID_choice1, *this);
            if (value && !value->empty()) m_uidMgr->RegisterReference(*value, *this);
        }
        m_sparUID_choice1 = value;
    }

    const boost::optional<double>& CPACSCellPositioningChordwise::GetContourCoordinate_choice2() const
    {
        return m_contourCoordinate_choice2;
    }

    void CPACSCellPositioningChordwise::SetContourCoordinate_choice2(const boost::optional<double>& value)
    {
        m_contourCoordinate_choice2 = value;
    }

    const boost::optional<double>& CPACSCellPositioningChordwise::GetXsi1_choice3() const
    {
        return m_xsi1_choice3;
    }

    void CPACSCellPositioningChordwise::SetXsi1_choice3(const boost::optional<double>& value)
    {
        m_xsi1_choice3 = value;
    }

    const boost::optional<double>& CPACSCellPositioningChordwise::GetXsi2_choice3() const
    {
        return m_xsi2_choice3;
    }

    void CPACSCellPositioningChordwise::SetXsi2_choice3(const boost::optional<double>& value)
    {
        m_xsi2_choice3 = value;
    }

    const CTiglUIDObject* CPACSCellPositioningChordwise::GetNextUIDObject() const
    {
        return GetNextUIDParent();
    }

    void CPACSCellPositioningChordwise::NotifyUIDChange(const std::string& oldUid, const std::string& newUid)
    {
        if (m_sparUID_choice1 && *m_sparUID_choice1 == oldUid) {
            m_sparUID_choice1 = newUid;
        }
    }

} // namespace generated
} // namespace tigl
