// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSFuselage.h"
#include "CPACSCompartment.h"
#include "CPACSCompartments.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSCompartments::CPACSCompartments(CCPACSFuselage* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSCompartments::~CPACSCompartments()
    {
    }

    const CCPACSFuselage* CPACSCompartments::GetParent() const
    {
        return m_parent;
    }

    CCPACSFuselage* CPACSCompartments::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSCompartments::GetNextUIDParent() const
    {
        return m_parent;
    }

    CTiglUIDObject* CPACSCompartments::GetNextUIDParent()
    {
        return m_parent;
    }

    CTiglUIDManager& CPACSCompartments::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSCompartments::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSCompartments::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element compartment
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/compartment")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/compartment", m_compartments, 1, tixi::xsdUnbounded, this, m_uidMgr);
        }

    }

    void CPACSCompartments::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element compartment
        tixi::TixiSaveElements(tixiHandle, xpath + "/compartment", m_compartments);

    }

    const std::vector<std::unique_ptr<CPACSCompartment>>& CPACSCompartments::GetCompartments() const
    {
        return m_compartments;
    }

    std::vector<std::unique_ptr<CPACSCompartment>>& CPACSCompartments::GetCompartments()
    {
        return m_compartments;
    }

    CPACSCompartment& CPACSCompartments::AddCompartment()
    {
        m_compartments.push_back(make_unique<CPACSCompartment>(this, m_uidMgr));
        return *m_compartments.back();
    }

    void CPACSCompartments::RemoveCompartment(CPACSCompartment& ref)
    {
        for (std::size_t i = 0; i < m_compartments.size(); i++) {
            if (m_compartments[i].get() == &ref) {
                m_compartments.erase(m_compartments.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
