// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSControlSurfaceOuterShapeTrailingEdge.h"
#include "CPACSControlSurfaceAirfoil.h"
#include "CPACSControlSurfaceContours.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSControlSurfaceContours::CPACSControlSurfaceContours(CCPACSControlSurfaceOuterShapeTrailingEdge* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSControlSurfaceContours::~CPACSControlSurfaceContours()
    {
    }

    const CCPACSControlSurfaceOuterShapeTrailingEdge* CPACSControlSurfaceContours::GetParent() const
    {
        return m_parent;
    }

    CCPACSControlSurfaceOuterShapeTrailingEdge* CPACSControlSurfaceContours::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSControlSurfaceContours::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSControlSurfaceContours::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSControlSurfaceContours::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSControlSurfaceContours::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSControlSurfaceContours::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element intermediateAirfoil
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/intermediateAirfoil")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/intermediateAirfoil", m_intermediateAirfoils, 1, tixi::xsdUnbounded, this, m_uidMgr);
        }

    }

    void CPACSControlSurfaceContours::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element intermediateAirfoil
        tixi::TixiSaveElements(tixiHandle, xpath + "/intermediateAirfoil", m_intermediateAirfoils);

    }

    const std::vector<std::unique_ptr<CPACSControlSurfaceAirfoil>>& CPACSControlSurfaceContours::GetIntermediateAirfoils() const
    {
        return m_intermediateAirfoils;
    }

    std::vector<std::unique_ptr<CPACSControlSurfaceAirfoil>>& CPACSControlSurfaceContours::GetIntermediateAirfoils()
    {
        return m_intermediateAirfoils;
    }

    CPACSControlSurfaceAirfoil& CPACSControlSurfaceContours::AddIntermediateAirfoil()
    {
        m_intermediateAirfoils.push_back(make_unique<CPACSControlSurfaceAirfoil>(this, m_uidMgr));
        return *m_intermediateAirfoils.back();
    }

    void CPACSControlSurfaceContours::RemoveIntermediateAirfoil(CPACSControlSurfaceAirfoil& ref)
    {
        for (std::size_t i = 0; i < m_intermediateAirfoils.size(); i++) {
            if (m_intermediateAirfoils[i].get() == &ref) {
                m_intermediateAirfoils.erase(m_intermediateAirfoils.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
