// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include <CCPACSNacelleProfile.h>
#include "CCPACSProfiles.h"
#include "CPACSCurveProfiles.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSCurveProfiles::CPACSCurveProfiles(CCPACSProfiles* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSCurveProfiles::~CPACSCurveProfiles()
    {
    }

    const CCPACSProfiles* CPACSCurveProfiles::GetParent() const
    {
        return m_parent;
    }

    CCPACSProfiles* CPACSCurveProfiles::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSCurveProfiles::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSCurveProfiles::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSCurveProfiles::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSCurveProfiles::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSCurveProfiles::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element curveProfile
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/curveProfile")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/curveProfile", m_curveProfiles, 1, tixi::xsdUnbounded, this, m_uidMgr);
        }

    }

    void CPACSCurveProfiles::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element curveProfile
        tixi::TixiSaveElements(tixiHandle, xpath + "/curveProfile", m_curveProfiles);

    }

    const std::vector<std::unique_ptr<CCPACSNacelleProfile>>& CPACSCurveProfiles::GetCurveProfiles() const
    {
        return m_curveProfiles;
    }

    std::vector<std::unique_ptr<CCPACSNacelleProfile>>& CPACSCurveProfiles::GetCurveProfiles()
    {
        return m_curveProfiles;
    }

    CCPACSNacelleProfile& CPACSCurveProfiles::AddCurveProfile()
    {
        m_curveProfiles.push_back(make_unique<CCPACSNacelleProfile>(this, m_uidMgr));
        return *m_curveProfiles.back();
    }

    void CPACSCurveProfiles::RemoveCurveProfile(CCPACSNacelleProfile& ref)
    {
        for (std::size_t i = 0; i < m_curveProfiles.size(); i++) {
            if (m_curveProfiles[i].get() == &ref) {
                m_curveProfiles.erase(m_curveProfiles.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
