// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSControlSurfaceWingCutOut.h"
#include "CPACSCutOutControlPoints.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSCutOutControlPoints::CPACSCutOutControlPoints(CCPACSControlSurfaceWingCutOut* parent)
        : m_innerBorder(this)
        , m_outerBorder(this)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSCutOutControlPoints::~CPACSCutOutControlPoints()
    {
    }

    const CCPACSControlSurfaceWingCutOut* CPACSCutOutControlPoints::GetParent() const
    {
        return m_parent;
    }

    CCPACSControlSurfaceWingCutOut* CPACSCutOutControlPoints::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSCutOutControlPoints::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSCutOutControlPoints::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    void CPACSCutOutControlPoints::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element innerBorder
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/innerBorder")) {
            m_innerBorder.ReadCPACS(tixiHandle, xpath + "/innerBorder");
        }
        else {
            LOG(ERROR) << "Required element innerBorder is missing at xpath " << xpath;
        }

        // read element outerBorder
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/outerBorder")) {
            m_outerBorder.ReadCPACS(tixiHandle, xpath + "/outerBorder");
        }
        else {
            LOG(ERROR) << "Required element outerBorder is missing at xpath " << xpath;
        }

    }

    void CPACSCutOutControlPoints::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element innerBorder
        tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/innerBorder");
        m_innerBorder.WriteCPACS(tixiHandle, xpath + "/innerBorder");

        // write element outerBorder
        tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/outerBorder");
        m_outerBorder.WriteCPACS(tixiHandle, xpath + "/outerBorder");

    }

    const CPACSCutOutControlPoint& CPACSCutOutControlPoints::GetInnerBorder() const
    {
        return m_innerBorder;
    }

    CPACSCutOutControlPoint& CPACSCutOutControlPoints::GetInnerBorder()
    {
        return m_innerBorder;
    }

    const CPACSCutOutControlPoint& CPACSCutOutControlPoints::GetOuterBorder() const
    {
        return m_outerBorder;
    }

    CPACSCutOutControlPoint& CPACSCutOutControlPoints::GetOuterBorder()
    {
        return m_outerBorder;
    }

} // namespace generated
} // namespace tigl
