// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CPACSDoorSurroundStructurePosition.h"
#include "CPACSDoorSurroundStructuresAssembly.h"
#include "CPACSStructuralElements.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSDoorSurroundStructuresAssembly::CPACSDoorSurroundStructuresAssembly(CPACSStructuralElements* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSDoorSurroundStructuresAssembly::~CPACSDoorSurroundStructuresAssembly()
    {
    }

    const CPACSStructuralElements* CPACSDoorSurroundStructuresAssembly::GetParent() const
    {
        return m_parent;
    }

    CPACSStructuralElements* CPACSDoorSurroundStructuresAssembly::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSDoorSurroundStructuresAssembly::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSDoorSurroundStructuresAssembly::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSDoorSurroundStructuresAssembly::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSDoorSurroundStructuresAssembly::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSDoorSurroundStructuresAssembly::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element doorSurroundStructure
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/doorSurroundStructure")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/doorSurroundStructure", m_doorSurroundStructures, 1, tixi::xsdUnbounded, this, m_uidMgr);
        }

    }

    void CPACSDoorSurroundStructuresAssembly::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element doorSurroundStructure
        tixi::TixiSaveElements(tixiHandle, xpath + "/doorSurroundStructure", m_doorSurroundStructures);

    }

    const std::vector<std::unique_ptr<CPACSDoorSurroundStructurePosition>>& CPACSDoorSurroundStructuresAssembly::GetDoorSurroundStructures() const
    {
        return m_doorSurroundStructures;
    }

    std::vector<std::unique_ptr<CPACSDoorSurroundStructurePosition>>& CPACSDoorSurroundStructuresAssembly::GetDoorSurroundStructures()
    {
        return m_doorSurroundStructures;
    }

    CPACSDoorSurroundStructurePosition& CPACSDoorSurroundStructuresAssembly::AddDoorSurroundStructure()
    {
        m_doorSurroundStructures.push_back(make_unique<CPACSDoorSurroundStructurePosition>(this, m_uidMgr));
        return *m_doorSurroundStructures.back();
    }

    void CPACSDoorSurroundStructuresAssembly::RemoveDoorSurroundStructure(CPACSDoorSurroundStructurePosition& ref)
    {
        for (std::size_t i = 0; i < m_doorSurroundStructures.size(); i++) {
            if (m_doorSurroundStructures[i].get() == &ref) {
                m_doorSurroundStructures.erase(m_doorSurroundStructures.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
