// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CPACSDoorCutOut.h"
#include "CPACSDoors.h"
#include "CPACSStructuralElements.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSDoors::CPACSDoors(CPACSStructuralElements* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSDoors::~CPACSDoors()
    {
    }

    const CPACSStructuralElements* CPACSDoors::GetParent() const
    {
        return m_parent;
    }

    CPACSStructuralElements* CPACSDoors::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSDoors::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSDoors::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSDoors::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSDoors::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSDoors::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element door
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/door")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/door", m_doors, 1, tixi::xsdUnbounded, reinterpret_cast<CCPACSDoors*>(this), m_uidMgr);
        }

    }

    void CPACSDoors::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element door
        tixi::TixiSaveElements(tixiHandle, xpath + "/door", m_doors);

    }

    const std::vector<std::unique_ptr<CPACSDoorCutOut>>& CPACSDoors::GetDoors() const
    {
        return m_doors;
    }

    std::vector<std::unique_ptr<CPACSDoorCutOut>>& CPACSDoors::GetDoors()
    {
        return m_doors;
    }

    CPACSDoorCutOut& CPACSDoors::AddDoor()
    {
        m_doors.push_back(make_unique<CPACSDoorCutOut>(reinterpret_cast<CCPACSDoors*>(this), m_uidMgr));
        return *m_doors.back();
    }

    void CPACSDoors::RemoveDoor(CPACSDoorCutOut& ref)
    {
        for (std::size_t i = 0; i < m_doors.size(); i++) {
            if (m_doors[i].get() == &ref) {
                m_doors.erase(m_doors.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
