// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSEnginePylons.h"
#include "CPACSEnginePylon.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSEnginePylon::CPACSEnginePylon(CCPACSEnginePylons* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
        , m_transformation(reinterpret_cast<CCPACSEnginePylon*>(this), m_uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSEnginePylon::~CPACSEnginePylon()
    {
        if (m_uidMgr) m_uidMgr->TryUnregisterObject(m_uID);
        if (m_uidMgr) {
            if (!m_parentUID.empty()) m_uidMgr->TryUnregisterReference(m_parentUID, *this);
        }
    }

    const CCPACSEnginePylons* CPACSEnginePylon::GetParent() const
    {
        return m_parent;
    }

    CCPACSEnginePylons* CPACSEnginePylon::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSEnginePylon::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSEnginePylon::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSEnginePylon::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSEnginePylon::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSEnginePylon::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read attribute uID
        if (tixi::TixiCheckAttribute(tixiHandle, xpath, "uID")) {
            m_uID = tixi::TixiGetAttribute<std::string>(tixiHandle, xpath, "uID");
            if (m_uID.empty()) {
                LOG(WARNING) << "Required attribute uID is empty at xpath " << xpath;
            }
        }
        else {
            LOG(ERROR) << "Required attribute uID is missing at xpath " << xpath;
        }

        // read attribute symmetry
        if (tixi::TixiCheckAttribute(tixiHandle, xpath, "symmetry")) {
            m_symmetry = stringToTiglSymmetryAxis(tixi::TixiGetAttribute<std::string>(tixiHandle, xpath, "symmetry"));
        }

        // read element name
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/name")) {
            m_name = tixi::TixiGetElement<std::string>(tixiHandle, xpath + "/name");
            if (m_name->empty()) {
                LOG(WARNING) << "Optional element name is present but empty at xpath " << xpath;
            }
        }

        // read element description
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/description")) {
            m_description = tixi::TixiGetElement<std::string>(tixiHandle, xpath + "/description");
            if (m_description->empty()) {
                LOG(WARNING) << "Optional element description is present but empty at xpath " << xpath;
            }
        }

        // read element parentUID
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/parentUID")) {
            m_parentUID = tixi::TixiGetElement<std::string>(tixiHandle, xpath + "/parentUID");
            if (m_parentUID.empty()) {
                LOG(WARNING) << "Required element parentUID is empty at xpath " << xpath;
            }
            if (m_uidMgr && !m_parentUID.empty()) m_uidMgr->RegisterReference(m_parentUID, *this);
        }
        else {
            LOG(ERROR) << "Required element parentUID is missing at xpath " << xpath;
        }

        // read element transformation
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/transformation")) {
            m_transformation.ReadCPACS(tixiHandle, xpath + "/transformation");
        }
        else {
            LOG(ERROR) << "Required element transformation is missing at xpath " << xpath;
        }

        // read element sections
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/sections")) {
            m_sections = boost::in_place(reinterpret_cast<CCPACSEnginePylon*>(this), m_uidMgr);
            try {
                m_sections->ReadCPACS(tixiHandle, xpath + "/sections");
            } catch(const std::exception& e) {
                LOG(ERROR) << "Failed to read sections at xpath " << xpath << ": " << e.what();
                m_sections = boost::none;
            }
        }

        // read element segments
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/segments")) {
            m_segments = boost::in_place(reinterpret_cast<CCPACSEnginePylon*>(this), m_uidMgr);
            try {
                m_segments->ReadCPACS(tixiHandle, xpath + "/segments");
            } catch(const std::exception& e) {
                LOG(ERROR) << "Failed to read segments at xpath " << xpath << ": " << e.what();
                m_segments = boost::none;
            }
        }

        // read element positionings
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/positionings")) {
            m_positionings = boost::in_place(reinterpret_cast<CCPACSEnginePylon*>(this), m_uidMgr);
            try {
                m_positionings->ReadCPACS(tixiHandle, xpath + "/positionings");
            } catch(const std::exception& e) {
                LOG(ERROR) << "Failed to read positionings at xpath " << xpath << ": " << e.what();
                m_positionings = boost::none;
            }
        }

        if (m_uidMgr && !m_uID.empty()) m_uidMgr->RegisterObject(m_uID, *this);
    }

    void CPACSEnginePylon::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write attribute uID
        tixi::TixiSaveAttribute(tixiHandle, xpath, "uID", m_uID);

        // write attribute symmetry
        if (m_symmetry) {
            tixi::TixiSaveAttribute(tixiHandle, xpath, "symmetry", TiglSymmetryAxisToString(*m_symmetry));
        }
        else {
            if (tixi::TixiCheckAttribute(tixiHandle, xpath, "symmetry")) {
                tixi::TixiRemoveAttribute(tixiHandle, xpath, "symmetry");
            }
        }

        // write element name
        if (m_name) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/name");
            tixi::TixiSaveElement(tixiHandle, xpath + "/name", *m_name);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/name")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/name");
            }
        }

        // write element description
        if (m_description) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/description");
            tixi::TixiSaveElement(tixiHandle, xpath + "/description", *m_description);
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/description")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/description");
            }
        }

        // write element parentUID
        tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/parentUID");
        tixi::TixiSaveElement(tixiHandle, xpath + "/parentUID", m_parentUID);

        // write element transformation
        tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/transformation");
        m_transformation.WriteCPACS(tixiHandle, xpath + "/transformation");

        // write element sections
        if (m_sections) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/sections");
            m_sections->WriteCPACS(tixiHandle, xpath + "/sections");
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/sections")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/sections");
            }
        }

        // write element segments
        if (m_segments) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/segments");
            m_segments->WriteCPACS(tixiHandle, xpath + "/segments");
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/segments")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/segments");
            }
        }

        // write element positionings
        if (m_positionings) {
            tixi::TixiCreateElementIfNotExists(tixiHandle, xpath + "/positionings");
            m_positionings->WriteCPACS(tixiHandle, xpath + "/positionings");
        }
        else {
            if (tixi::TixiCheckElement(tixiHandle, xpath + "/positionings")) {
                tixi::TixiRemoveElement(tixiHandle, xpath + "/positionings");
            }
        }

    }

    const std::string& CPACSEnginePylon::GetUID() const
    {
        return m_uID;
    }

    void CPACSEnginePylon::SetUID(const std::string& value)
    {
        if (m_uidMgr && value != m_uID) {
            if (m_uID.empty()) {
                m_uidMgr->RegisterObject(value, *this);
            }
            else {
                m_uidMgr->UpdateObjectUID(m_uID, value);
            }
        }
        m_uID = value;
    }

    const boost::optional<TiglSymmetryAxis>& CPACSEnginePylon::GetSymmetry() const
    {
        return m_symmetry;
    }

    void CPACSEnginePylon::SetSymmetry(const boost::optional<TiglSymmetryAxis>& value)
    {
        m_symmetry = value;
    }

    const boost::optional<std::string>& CPACSEnginePylon::GetName() const
    {
        return m_name;
    }

    void CPACSEnginePylon::SetName(const boost::optional<std::string>& value)
    {
        m_name = value;
    }

    const boost::optional<std::string>& CPACSEnginePylon::GetDescription() const
    {
        return m_description;
    }

    void CPACSEnginePylon::SetDescription(const boost::optional<std::string>& value)
    {
        m_description = value;
    }

    const std::string& CPACSEnginePylon::GetParentUID() const
    {
        return m_parentUID;
    }

    void CPACSEnginePylon::SetParentUID(const std::string& value)
    {
        if (m_uidMgr) {
            if (!m_parentUID.empty()) m_uidMgr->TryUnregisterReference(m_parentUID, *this);
            if (!value.empty()) m_uidMgr->RegisterReference(value, *this);
        }
        m_parentUID = value;
    }

    const CCPACSTransformation& CPACSEnginePylon::GetTransformation() const
    {
        return m_transformation;
    }

    CCPACSTransformation& CPACSEnginePylon::GetTransformation()
    {
        return m_transformation;
    }

    const boost::optional<CCPACSWingSections>& CPACSEnginePylon::GetSections() const
    {
        return m_sections;
    }

    boost::optional<CCPACSWingSections>& CPACSEnginePylon::GetSections()
    {
        return m_sections;
    }

    const boost::optional<CCPACSWingSegments>& CPACSEnginePylon::GetSegments() const
    {
        return m_segments;
    }

    boost::optional<CCPACSWingSegments>& CPACSEnginePylon::GetSegments()
    {
        return m_segments;
    }

    const boost::optional<CCPACSPositionings>& CPACSEnginePylon::GetPositionings() const
    {
        return m_positionings;
    }

    boost::optional<CCPACSPositionings>& CPACSEnginePylon::GetPositionings()
    {
        return m_positionings;
    }

    CCPACSWingSections& CPACSEnginePylon::GetSections(CreateIfNotExistsTag)
    {
        if (!m_sections)
            m_sections = boost::in_place(reinterpret_cast<CCPACSEnginePylon*>(this), m_uidMgr);
        return *m_sections;
    }

    void CPACSEnginePylon::RemoveSections()
    {
        m_sections = boost::none;
    }

    CCPACSWingSegments& CPACSEnginePylon::GetSegments(CreateIfNotExistsTag)
    {
        if (!m_segments)
            m_segments = boost::in_place(reinterpret_cast<CCPACSEnginePylon*>(this), m_uidMgr);
        return *m_segments;
    }

    void CPACSEnginePylon::RemoveSegments()
    {
        m_segments = boost::none;
    }

    CCPACSPositionings& CPACSEnginePylon::GetPositionings(CreateIfNotExistsTag)
    {
        if (!m_positionings)
            m_positionings = boost::in_place(reinterpret_cast<CCPACSEnginePylon*>(this), m_uidMgr);
        return *m_positionings;
    }

    void CPACSEnginePylon::RemovePositionings()
    {
        m_positionings = boost::none;
    }

    const CTiglUIDObject* CPACSEnginePylon::GetNextUIDObject() const
    {
        return this;
    }

    void CPACSEnginePylon::NotifyUIDChange(const std::string& oldUid, const std::string& newUid)
    {
        if (m_parentUID == oldUid) {
            m_parentUID = newUid;
        }
    }

} // namespace generated
} // namespace tigl
