// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include <CCPACSLongFloorBeamPosition.h>
#include "CCPACSLongFloorBeamsAssembly.h"
#include "CPACSLongFloorBeam.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSLongFloorBeam::CPACSLongFloorBeam(CCPACSLongFloorBeamsAssembly* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSLongFloorBeam::~CPACSLongFloorBeam()
    {
        if (m_uidMgr) m_uidMgr->TryUnregisterObject(m_uID);
    }

    const CCPACSLongFloorBeamsAssembly* CPACSLongFloorBeam::GetParent() const
    {
        return m_parent;
    }

    CCPACSLongFloorBeamsAssembly* CPACSLongFloorBeam::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSLongFloorBeam::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSLongFloorBeam::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSLongFloorBeam::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSLongFloorBeam::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSLongFloorBeam::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read attribute uID
        if (tixi::TixiCheckAttribute(tixiHandle, xpath, "uID")) {
            m_uID = tixi::TixiGetAttribute<std::string>(tixiHandle, xpath, "uID");
            if (m_uID.empty()) {
                LOG(WARNING) << "Required attribute uID is empty at xpath " << xpath;
            }
        }
        else {
            LOG(ERROR) << "Required attribute uID is missing at xpath " << xpath;
        }

        // read element longFloorBeamPosition
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/longFloorBeamPosition")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/longFloorBeamPosition", m_longFloorBeamPositions, 2, tixi::xsdUnbounded, reinterpret_cast<CCPACSLongFloorBeam*>(this), m_uidMgr);
        }

        if (m_uidMgr && !m_uID.empty()) m_uidMgr->RegisterObject(m_uID, *this);
    }

    void CPACSLongFloorBeam::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write attribute uID
        tixi::TixiSaveAttribute(tixiHandle, xpath, "uID", m_uID);

        // write element longFloorBeamPosition
        tixi::TixiSaveElements(tixiHandle, xpath + "/longFloorBeamPosition", m_longFloorBeamPositions);

    }

    const std::string& CPACSLongFloorBeam::GetUID() const
    {
        return m_uID;
    }

    void CPACSLongFloorBeam::SetUID(const std::string& value)
    {
        if (m_uidMgr && value != m_uID) {
            if (m_uID.empty()) {
                m_uidMgr->RegisterObject(value, *this);
            }
            else {
                m_uidMgr->UpdateObjectUID(m_uID, value);
            }
        }
        m_uID = value;
    }

    const std::vector<std::unique_ptr<CCPACSLongFloorBeamPosition>>& CPACSLongFloorBeam::GetLongFloorBeamPositions() const
    {
        return m_longFloorBeamPositions;
    }

    std::vector<std::unique_ptr<CCPACSLongFloorBeamPosition>>& CPACSLongFloorBeam::GetLongFloorBeamPositions()
    {
        return m_longFloorBeamPositions;
    }

    CCPACSLongFloorBeamPosition& CPACSLongFloorBeam::AddLongFloorBeamPosition()
    {
        m_longFloorBeamPositions.push_back(make_unique<CCPACSLongFloorBeamPosition>(reinterpret_cast<CCPACSLongFloorBeam*>(this), m_uidMgr));
        return *m_longFloorBeamPositions.back();
    }

    void CPACSLongFloorBeam::RemoveLongFloorBeamPosition(CCPACSLongFloorBeamPosition& ref)
    {
        for (std::size_t i = 0; i < m_longFloorBeamPositions.size(); i++) {
            if (m_longFloorBeamPositions[i].get() == &ref) {
                m_longFloorBeamPositions.erase(m_longFloorBeamPositions.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
