// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CCPACSNacelleCowl.h"
#include "CPACSNacelleGuideCurve.h"
#include "CPACSNacelleGuideCurves.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSNacelleGuideCurves::CPACSNacelleGuideCurves(CCPACSNacelleCowl* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSNacelleGuideCurves::~CPACSNacelleGuideCurves()
    {
    }

    const CCPACSNacelleCowl* CPACSNacelleGuideCurves::GetParent() const
    {
        return m_parent;
    }

    CCPACSNacelleCowl* CPACSNacelleGuideCurves::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSNacelleGuideCurves::GetNextUIDParent() const
    {
        return m_parent;
    }

    CTiglUIDObject* CPACSNacelleGuideCurves::GetNextUIDParent()
    {
        return m_parent;
    }

    CTiglUIDManager& CPACSNacelleGuideCurves::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSNacelleGuideCurves::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSNacelleGuideCurves::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element nacelleGuideCurve
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/nacelleGuideCurve")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/nacelleGuideCurve", m_nacelleGuideCurves, 1, tixi::xsdUnbounded, reinterpret_cast<CCPACSNacelleGuideCurves*>(this), m_uidMgr);
        }

    }

    void CPACSNacelleGuideCurves::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element nacelleGuideCurve
        tixi::TixiSaveElements(tixiHandle, xpath + "/nacelleGuideCurve", m_nacelleGuideCurves);

    }

    const std::vector<std::unique_ptr<CPACSNacelleGuideCurve>>& CPACSNacelleGuideCurves::GetNacelleGuideCurves() const
    {
        return m_nacelleGuideCurves;
    }

    std::vector<std::unique_ptr<CPACSNacelleGuideCurve>>& CPACSNacelleGuideCurves::GetNacelleGuideCurves()
    {
        return m_nacelleGuideCurves;
    }

    CPACSNacelleGuideCurve& CPACSNacelleGuideCurves::AddNacelleGuideCurve()
    {
        m_nacelleGuideCurves.push_back(make_unique<CPACSNacelleGuideCurve>(reinterpret_cast<CCPACSNacelleGuideCurves*>(this), m_uidMgr));
        return *m_nacelleGuideCurves.back();
    }

    void CPACSNacelleGuideCurves::RemoveNacelleGuideCurve(CPACSNacelleGuideCurve& ref)
    {
        for (std::size_t i = 0; i < m_nacelleGuideCurves.size(); i++) {
            if (m_nacelleGuideCurves[i].get() == &ref) {
                m_nacelleGuideCurves.erase(m_nacelleGuideCurves.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
