// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include <CCPACSFuselageWallSegment.h>
#include "CCPACSWalls.h"
#include "CPACSWallSegments.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "CTiglUIDObject.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSWallSegments::CPACSWallSegments(CCPACSWalls* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSWallSegments::~CPACSWallSegments()
    {
    }

    const CCPACSWalls* CPACSWallSegments::GetParent() const
    {
        return m_parent;
    }

    CCPACSWalls* CPACSWallSegments::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSWallSegments::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSWallSegments::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSWallSegments::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSWallSegments::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSWallSegments::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read element wallSegment
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/wallSegment")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/wallSegment", m_wallSegments, 1, tixi::xsdUnbounded, this, m_uidMgr);
        }

    }

    void CPACSWallSegments::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write element wallSegment
        tixi::TixiSaveElements(tixiHandle, xpath + "/wallSegment", m_wallSegments);

    }

    const std::vector<std::unique_ptr<CCPACSFuselageWallSegment>>& CPACSWallSegments::GetWallSegments() const
    {
        return m_wallSegments;
    }

    std::vector<std::unique_ptr<CCPACSFuselageWallSegment>>& CPACSWallSegments::GetWallSegments()
    {
        return m_wallSegments;
    }

    CCPACSFuselageWallSegment& CPACSWallSegments::AddWallSegment()
    {
        m_wallSegments.push_back(make_unique<CCPACSFuselageWallSegment>(this, m_uidMgr));
        return *m_wallSegments.back();
    }

    void CPACSWallSegments::RemoveWallSegment(CCPACSFuselageWallSegment& ref)
    {
        for (std::size_t i = 0; i < m_wallSegments.size(); i++) {
            if (m_wallSegments[i].get() == &ref) {
                m_wallSegments.erase(m_wallSegments.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
