// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cassert>
#include "CPACSCutOut.h"
#include "CPACSStructuralElements.h"
#include "CPACSWindows.h"
#include "CTiglError.h"
#include "CTiglLogging.h"
#include "CTiglUIDManager.h"
#include "TixiHelper.h"

namespace tigl
{
namespace generated
{
    CPACSWindows::CPACSWindows(CPACSStructuralElements* parent, CTiglUIDManager* uidMgr)
        : m_uidMgr(uidMgr)
    {
        //assert(parent != NULL);
        m_parent = parent;
    }

    CPACSWindows::~CPACSWindows()
    {
        if (m_uidMgr) m_uidMgr->TryUnregisterObject(m_uID);
    }

    const CPACSStructuralElements* CPACSWindows::GetParent() const
    {
        return m_parent;
    }

    CPACSStructuralElements* CPACSWindows::GetParent()
    {
        return m_parent;
    }

    const CTiglUIDObject* CPACSWindows::GetNextUIDParent() const
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDObject* CPACSWindows::GetNextUIDParent()
    {
        if (m_parent) {
            return m_parent->GetNextUIDParent();
        }
        return nullptr;
    }

    CTiglUIDManager& CPACSWindows::GetUIDManager()
    {
        return *m_uidMgr;
    }

    const CTiglUIDManager& CPACSWindows::GetUIDManager() const
    {
        return *m_uidMgr;
    }

    void CPACSWindows::ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath)
    {
        // read attribute uID
        if (tixi::TixiCheckAttribute(tixiHandle, xpath, "uID")) {
            m_uID = tixi::TixiGetAttribute<std::string>(tixiHandle, xpath, "uID");
            if (m_uID.empty()) {
                LOG(WARNING) << "Required attribute uID is empty at xpath " << xpath;
            }
        }
        else {
            LOG(ERROR) << "Required attribute uID is missing at xpath " << xpath;
        }

        // read element window
        if (tixi::TixiCheckElement(tixiHandle, xpath + "/window")) {
            tixi::TixiReadElements(tixiHandle, xpath + "/window", m_windows, 1, tixi::xsdUnbounded, this, m_uidMgr);
        }

        if (m_uidMgr && !m_uID.empty()) m_uidMgr->RegisterObject(m_uID, *this);
    }

    void CPACSWindows::WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const
    {
        // write attribute uID
        tixi::TixiSaveAttribute(tixiHandle, xpath, "uID", m_uID);

        // write element window
        tixi::TixiSaveElements(tixiHandle, xpath + "/window", m_windows);

    }

    const std::string& CPACSWindows::GetUID() const
    {
        return m_uID;
    }

    void CPACSWindows::SetUID(const std::string& value)
    {
        if (m_uidMgr && value != m_uID) {
            if (m_uID.empty()) {
                m_uidMgr->RegisterObject(value, *this);
            }
            else {
                m_uidMgr->UpdateObjectUID(m_uID, value);
            }
        }
        m_uID = value;
    }

    const std::vector<std::unique_ptr<CPACSCutOut>>& CPACSWindows::GetWindows() const
    {
        return m_windows;
    }

    std::vector<std::unique_ptr<CPACSCutOut>>& CPACSWindows::GetWindows()
    {
        return m_windows;
    }

    CPACSCutOut& CPACSWindows::AddWindow()
    {
        m_windows.push_back(make_unique<CPACSCutOut>(this, m_uidMgr));
        return *m_windows.back();
    }

    void CPACSWindows::RemoveWindow(CPACSCutOut& ref)
    {
        for (std::size_t i = 0; i < m_windows.size(); i++) {
            if (m_windows[i].get() == &ref) {
                m_windows.erase(m_windows.begin() + i);
                return;
            }
        }
        throw CTiglError("Element not found");
    }

} // namespace generated
} // namespace tigl
